require 'erubis'
require 'fileutils'
require 'yaml'
require 'active_support/all'
require_relative './files'


def eruby_script_relative_file(name)
  Erubis::Eruby.new(File.read(File.expand_path("../templates/#{name}.eruby", __FILE__)))
end

dirname = File.basename(Dir.getwd)
if(dirname != "app")
    abort("Please run this script under app folder")
end

settings = {}

if(ARGV.empty?)
  puts "Enter the module you want to add java classes: "
  settings[:module_name] = gets.chomp
  puts "Enter package name: (jp.co.worksap.company.web.{package name}.service"
  settings[:package] = gets.chomp
  puts "Using package name: jp.co.worksap.company.web.#{settings[:package]}.*"
  puts
  puts "Enter plain name: (something_useful)"
  settings[:name] = gets.chomp
  puts "Using plain name: #{settings[:name]} and class name #{settings[:name].camelize}*"
  puts
  puts "Enter function name: "
  settings[:func_name] = gets.chomp
  puts "Using function name: #{settings[:func_name]}"
else
  settings = YAML.load(File.read(ARGV[0])).symbolize_keys
end



files = [
  JavaFile.new('service', 'Service'),
  JavaFile.new('ri', "RI"),
  WebFile.new('css'),
  WebFile.new('js'),
  WebFile.new('xml')
].each do |file|
  eruby = eruby_script_relative_file(file.eruby)
  path = file.path(settings)
  dir, fname = File.split(path)
  FileUtils.mkdir_p(dir)
  File.open(path, 'w') do |f|
    f.write(eruby.result(settings))
  end
end
